/* mkPmtIstFc-1.cc */
/* Jan 6 2007 */

// ʗϊ֌WAyp[^AHw_WuOaEsOa
// @\𓱓ʗϊ֌W̊J, 48, 2004, EiJEv
// Ŏ̂ɕύXBvOg̒g͉iJCm_Ŏgp̂ƓB

// gcc v 3.4 ŃRpCł悤ɂB by YT
/*

[vO]

mkPmtIstFc-1.cc

[o[Wԍ]

ver. 1.1

[vO]

mkPmtIstFc-1.cc ́AKsEdgeFc f

  o p^t@C (KsEdgeFc Parameter Format)
  o ʃt@C (KsEdgeFc Initial State Format)

쐬vOłB

̃vO ́Aedge connection V.1, V.2, V.3, V.4, V.5 ̂ɂ
ΉĂ܂B

܂ł̃vOƂ̈Ⴂ́Aԗ (eGbW㉺[ł̗) 
ݒ̎dłB̓t@CƂ edge connection V.1, V.2, V.4 ǂݍ
ꍇ́A܂Œʂ㉺[̗ʂW͂͂AׂẴGbW㉺
[ŗʂɂȂ܂Bedge connection V.3, V.5 ǂݍ񂾏ꍇɂ́AvZ
Jn̗o (mm/hour) ^āAeGbW㉺[ɂԂ̗
vZAԗʂƂ܂BƂ΁AvZJn̗o r, 
GbW̏㗬̖ʐς Au, ̃GbW̖ʐς Ac ƂƁA
GbW̏[ł̏ Qu, [ł̏ Qc ͂ꂼA

  Qu = r * Au
  Qc = r * (Au + Ac)

ƂȂ܂B

[g]

1) ŋN܂B

% mkPmtIstFc-1 < mkPI.input

--- example of mkPI.input ---
ecv5/ecv5-all.dat
y
99-6-24.pmt
y
99-6-24.ist
y
0.3
y
1.667
y
0.01
y
1.0
y
0.55
y
0.45
y
4.0
y
0.65
y
0.0000001
y
10
y
0.0001
y
10
y
1.00
y
--- ܂ ---

2) ȂŋN܂B

% mkPmtIstFc-1
# input file (edge connection V.1, V.2, V.3, V.4 or V.5) : iFile
# output file (KsEdgeFc Parameter Format) : oFile1
# output file (KsEdgeFc Initial State Format) : oFile2

# input values.
# [] means recommended value. () means unit system.

# manning coefficient (m-s) n : 0.3
# kinematic parameter m [1.667] (-) : 1.667
# hydraulic conductivity (m/s), ka : 0.01
# depth of soil layer (m), D : 1.0
# depth of A-layer (m), da : 0.55
# depth of field capacity (m), dm : 0.45
# beta [> 1.0] (-) : 4.0
# theta [0.65] (-) : 0.65
# minimum value of C = dQ/dA [0.000001] (m/s) : 0.0000001
# Qlevel [10] (mm/hour) : 10
# eps [0.0001] (-) : 0.0001
# number of spatial division (-) : 10

(edge connection V.1, V.2, V.4 ǂݍ񂾏ꍇ)

# discharge at upper end (m3/s) : 0.0
# discharge at lower end (m3/s) : 0.0

(edge connection V.3, V.5 ǂݍ񂾏ꍇ)

# initial runoff height (mm/hour) : 0.1

[̓t@C̃tH[}bg]

edge connection V.1, V.2, V.3, V.4, V.5 ̂ꂩł܂܂B

[RpC]

% make

*/

#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <assert.h>
#include <stdlib.h>

#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khstr.h"
#include "khdfstream.h"
#include "nopath.h"

using namespace std;

void usage(const KhString& command)
{
  cerr
  << "\n" << command << " produces KsEdgeFc Parameter Format data and KsEdgeFc Initial State data\n"
  << "usage: " << command << " [options]\n"
  << "  options: \n"
  << "    -h  show this help message\n"
  << "    -v  show version number\n"
  << "  iFile  : edge connection V.1, V.2, V.3, V.4 or V.5 data\n"
  << "  oFile1 : KsEdgeFc Parameter Format data\n"
  << "  oFile2 : KsEdgeFc Initial State data\n"
  << "  \"iFile\", \"oFile1\" and \"oFile2\" will be read in from STDIN\n"
  << "  with prompting messages.\n" << endl;
  exit(1);
}

void version(void)
{
  cerr << "\nThis is mkPmtIstFc-1 ver. 1.1\n"
       << "developed by Yutaka ICHIKAWA, Kyoto Univ.\n" 
       << "modified by Y. TACHIKAWA, Kyoto Univ.\n" << endl;
}

int main						// CvO
(
 int argc,
 char** argv
 )
{
  KhString command = nopath(argv[0]);
  
  // optstring ŁAIvVƂċw肵܂B
  char *optstring = "hv";
  
  int c;
  while((c = getopt(argc, argv, optstring)) != EOF)
    {
      // getopt ͉͂IvVԂ܂B
      switch (c) {
      case 'v':
	version();
	break;
      case 'h':
	// IvV h ԂĂꍇ̏
	// fall through
      default:
	usage(command);
      }
    }
  
  // argc ɂ, R}hƈ̌܂BȂ
  // ƂCargc ɂ 1 ܂B
  
  if (argc != 1)
    {
      //  command ł́Ǎ0łB
      usage(command);
    }
  
  char in[256], out[256], out2[256];
  double man;
  double m;
  double ka;
  double D;
  double da;
  double dm;
  double beta;
  double theta;
  double cmin;
  double Qlevel;
  double eps;
  int ndiv;
  
  KhBoolean ans = NO;
  char wbuf[256];
  
  while (ans == NO) 
    {
      cout << "# input file (edge connection V.1, V.2, V.3, V.4 or V.5) : ";
      cin >> in;
      cout << in << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  KhDfstream iFile(in);
  if (!iFile)
    {
      cerr << "E: no such file." << endl;
      exit(1);
    }
  
  KhString buf;
  //	while (getline(iFile, buf) && buf != "[Data Format Name]") ;
  while (getline(iFile, buf) && 
	 strncmp((const char *)buf, "[Data Format Name]", 18) != 0) ;
  getline(iFile, buf);
  // 	if (buf != "edge connection V.1" && buf != "edge connection V.2" &&
  // 		buf != "edge connection V.3")
  if (strncmp((const char *)buf, "edge connection V.1", 19) != 0 && 
      strncmp((const char *)buf, "edge connection V.2", 19) != 0 &&
      strncmp((const char *)buf, "edge connection V.3", 19) != 0 &&
      strncmp((const char *)buf, "edge connection V.4", 19) != 0 &&
      strncmp((const char *)buf, "edge connection V.5", 19) != 0)
    {
      cerr << "E: invalid data format." << endl;
      exit(1);
    }
  
  // f[^tH[}bg̎
  int topoDataType;
  // 	if (buf == "edge connection V.1") topoDataType = 1;
  // 	else if (buf == "edge connection V.2") topoDataType = 2;
  // 	else topoDataType = 3;
  
  if (strncmp((const char *)buf, "edge connection V.1", 19) == 0)
    topoDataType = 1;
  else if (strncmp((const char *)buf, "edge connection V.2", 19) == 0)
    topoDataType = 2;
  else if (strncmp((const char *)buf, "edge connection V.3", 19) == 0)
    topoDataType = 3;
  else if (strncmp((const char *)buf, "edge connection V.4", 19) == 0)
    topoDataType = 4;
  else
    topoDataType = 5;
  
  ans = NO;
  while (ans == NO) 
    {
      cout << "# output file (KsEdgeFc Parameter Format) : ";
      cin >> out;
      cout << out << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# output file (KsEdgeFc Initial State Format) : ";
      cin >> out2;
      cout << out2 << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  cout << "\n"
       << "# input values.\n"
       << "# [] means recommended value. () means unit system.\n"
       << endl;
  
  while (ans == NO) 
    {
      cout << "# manning coefficient (m-s) : ";
      cin >> man;
      cout << man << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# kinematic parameter m [1.667](-) : ";
      cin >> m;
      cout << m << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# hydraulic conductivity (m/s) : ";
      cin >> ka;
      cout << ka << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# depth of soil layer (m) : ";
      cin >> D;
      cout << D << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# depth of A-layer (m) : ";
      cin >> da;
      cout << da << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  // Matrix soil layer
  while (ans == NO) 
    {
      cout << "# depth of matrix soil layer (m) : ";
      cin >> dm;
      cout << dm << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  // beta
  while (ans == NO) 
    {
      cout << "# beta (-)( 2.0 < beta <10.0) : ";
      cin >> beta;
      cout << beta << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# theta [0.65](-) : ";
      cin >> theta;
      cout << theta << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# minimum value of C = dQ/dA [0.000001](m/s) : ";
      cin >> cmin;
      cout << cmin << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# Qlevel [10](mm/hour) : ";
      cin >> Qlevel;
      cout << Qlevel << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# eps [0.0001](-) : ";
      cin >> eps;
      cout << eps << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  while (ans == NO) 
    {
      cout << "# number of spatial division (-) : ";
      cin >> ndiv;
      cout << ndiv << "; ok? [y/n] : ";
      cin >> wbuf;
      if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
    }
  ans = NO;
  
  // ԗʂ̓
  
  double updis, lowdis;	   // GbW㉺[ł̗
  double irunoff;
  
  if (topoDataType == 1 || topoDataType == 2 || topoDataType == 4)
    {
      while (ans == NO) 
	{
	  cout << "# discharge at upper end (m3/s) : ";
	  cin >> updis;
	  cout << updis << "; ok? [y/n] : ";
	  cin >> wbuf;
	  if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
      ans = NO;
      
      while (ans == NO) 
	{
	  cout << endl;
	  cout << "# discharge at lower end (m3/s) : ";
	  cin >> lowdis;
	  cout << lowdis << "; ok? [y/n] : ";
	  cin >> wbuf;
	  if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
      ans = NO;
    }
  else
    {
      while (ans == NO) 
	{
	  cout << endl;
	  cout << "# initial runoff height (mm/hour) : ";
	  cin >> irunoff;
	  cout << irunoff << "; ok? [y/n] : ";
	  cin >> wbuf;
	  if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
    }
  
  ofstream oFile(out);
  ofstream oFile2(out2);
  
  oFile << "[Comment]\n" 
	<< "This data was generated from " << in 
	<< " by " << command << ".\n"
	<< "Each column in [Data] section is as follows:\n"
	<< "<edge number>\n<manning coefficient (m-s)>\n"
	<< "<kinematic parameter m (-)>\n"
	<< "<hydraulic conductivity (m/s)>\n"
	<< "<depth of soil layer (m)>\n"
	<< "<depth of A-layer (m)>\n"
	<< "<depth of soil matrix layer (m)>\n"
	<< "<beta (-)>\n"
	<< "<theta>\n<minimun C = dQ/dA(m/s)>\n"
	<< "<Qlevel(mm/hour)>\n<eps(-)>\n"
	<< "<number of spatial division(-)>"
	<< endl;
  
  oFile << "[Data Format Name]\n"
	<< "KsEdgeFc Parameter Format" << endl;
  
  oFile2 << "[Comment]\n"
	 << "This data was generated from " << in 
	 << " by " << command << ".\n"
	 << "Each column in [Data] section is as follows:\n"
	 << "<edge number>\n"
	 << "<discharge at upper end(m3/s)>\n"
	 << "<discharge at lower end(m3/s)>"
	 << endl;
  
  oFile2 << "[Data Format Name]\n"
	 << "KsEdgeFc Initial State Format" << endl;
  
  //	while (getline(iFile, buf) && buf != "[Number of Total Edges]") ;
  while (getline(iFile, buf) && 
	 strncmp((const char *)buf, "[Number of Total Edges]", 23) != 0) ;
  
  long numberOfTotalEdges;
  getline(iFile, buf);
  
  // istrstream strmbuf(buf);
  istringstream strmbuf((const char*)buf);
  
  strmbuf >> numberOfTotalEdges;
  oFile << "[Number of Total Edges]\n" << numberOfTotalEdges << endl;
  oFile2 << "[Number of Total Edges]\n" << numberOfTotalEdges << endl;
  
  //	while (getline(iFile, buf) && buf != "[Data]") ;
  while (getline(iFile, buf) && 
	 strncmp((const char *)buf, "[Data]", 6) != 0) ;
  
  oFile << "[Data]" << endl;
  oFile2 << "[Data]" << endl;
  
  while (getline(iFile, buf)) 
    {
      long num;				   // GbWԍ
      double x, y, z;			   // _̍W(sv)
      long upperNode, lowerNode; // GbW㉺[̃m[hԍ
      double upx, upy, upz, lowx, lowy, lowz;	// GbW㉺[̍W(sv)
      double upnum, lownum, tmp; // ㉺GbW̐Aԍ(sv)
      int atr;				   // 
      double len, grd, area;	   // GbW̒AzAʐ
      double dist, upArea;	   // ʕzA㗬̖ʐ
      
      // istrstream strmdata(buf);
      istringstream strmdata((const char*)buf);
      
      strmdata >> num ;
      
      if (topoDataType == 2 || topoDataType == 3)
	strmdata >> x >> y >> z ;
      else if (topoDataType == 4 || topoDataType == 5)
	strmdata >> upperNode >> upx >> upy >> upz 
		 >> lowerNode >> lowx >> lowy >> lowz ;
      
      strmdata >> upnum ;
      for (int i = 0; i < upnum; i++) strmdata >> tmp ;
      strmdata >> lownum ;
      for (int i = 0; i < lownum; i++) strmdata >> tmp ;
      strmdata >> atr ;
      
      if (atr == 1)			// _-_GbW
	{
	  strmdata >> len >> grd >> area ;
	}
      else if (atr == 2)		// _-͓_GbW
	{
	  len = grd = area = 0.0;
	}
      else
	{
	  strmdata >> len >> grd ;
	  area = 0.0;
	}
      
      if (topoDataType == 3 || topoDataType == 5)
	strmdata >> dist >> upArea ;
      
      // p^
      oFile << num << " " << man << " " << m << " " 
	    << ka << " " << D << " " << da << " " 
	    << dm << " " << beta << " "
	    << theta << " " << cmin << " " << Qlevel << " " 
	    << eps << " " << ndiv << endl;
      
      // ԗ [m3/s]
      if (topoDataType == 1 || topoDataType == 2 || topoDataType == 4)
	{
	  oFile2 << num << " " << updis << " " << lowdis << endl;
	}
      else
	{
	  oFile2 << num << " " << irunoff * upArea * 0.001 / 3600.0 << " " 
		 << irunoff * (upArea + area) * 0.001 / 3600.0 << endl;
	}
    }
  
  return 0;
}
